#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <regex.h>

int main(int argc, char *argv[]) {
#define SIZE 80
   char buf[SIZE],
        errbuf[SIZE] = "",
        pattern[SIZE] = "[0-9]";      
#define MATCHSIZE 20
   regmatch_t regs[MATCHSIZE];
   regex_t re, *pre = &re;
   if (argc > 1) strncpy(pattern, argv[1], SIZE - 1);      
   int err = regcomp(pre, pattern, REG_ICASE | REG_EXTENDED); 
   if (err) {
       regerror(err, pre, errbuf, SIZE);
       printf("%s\n", errbuf);    
       return 1;
   }
   while (fgets(buf, sizeof(buf) - 1, stdin)) {
      if (buf[strlen(buf) - 1] == '\n') buf[strlen(buf) - 1] = '\0';
      if (0 == strlen(buf)) break; // выход
      if (REG_NOMATCH == regexec(pre, buf, MATCHSIZE, regs, 0)) {
         printf("no match found\n");
         continue;
      }
      for (int c = 0; regs[c].rm_so != -1; c++) {
         printf("%d/%d : ", regs[c].rm_so, regs[c].rm_eo);
         for (int i = regs[c].rm_so; i < regs[c].rm_eo; i++) 
            printf("%c", buf[i]);
         printf("\n");    
      }
   }
   regfree(pre);
   return 0;
}
