#include <stdio.h>
#include <string.h>
#include <pcre.h>

int main(int argc, char *argv[]) {
#define SIZE 80
   char buf[SIZE] = "test test test test ",
        pattern[SIZE] = "s";      
   if (argc > 1) strncpy(pattern, argv[1], SIZE - 1);
   const unsigned char *locale_tables = pcre_maketables();
   const char *error;
   int erroffset;
   pcre *re = pcre_compile((char*)pattern, 0, &error, &erroffset, locale_tables);
   if (!re) {
      printf("pattern compile error: %s\n", error);      
      return 1;
   }
#define MATCHSIZE 20
   int ovector[MATCHSIZE * 2];
   while (fgets(buf, sizeof(buf) - 1, stdin)) {
      if (buf[strlen(buf) - 1] == '\n') buf[strlen(buf) - 1] = '\0';
      if (0 == strlen(buf)) break; // выход
      int count = pcre_exec(re, NULL, (char*)buf, strlen(buf), 0, 0, ovector, MATCHSIZE);
      if (count < 0) {
         printf("no match found\n");
         continue;
      }
      for (int c = 0; (c < 2 * count) && (ovector[c] >= 0); c += 2) {
         printf("%d/%d : ", ovector[c], ovector[c + 1]);
         for (int i = ovector[c]; i < ovector[c + 1]; i++) 
            printf("%c", buf[i]);
         printf("\n");    
      }
   }
   pcre_free(re);
   return 0;
}
