#include <stdio.h>
#include <string.h>
#include <pcre2posix.h>

int main(int argc, char *argv[]) {
#define SIZE 120
   char buf[SIZE] = "test test test test ";
   char pattern[SIZE] = "s";      
   if (argc > 1) strncpy(pattern, argv[1], SIZE - 1);
   regex_t preg;
   if (pcre2_regcomp(&preg, (char*)&pattern, 
       REG_UCP | REG_UTF | REG_ICASE) != 0) {
      printf("pattern compile error: %m\n");      
      return 1;
   }
   while (fgets(buf, sizeof(buf) - 1, stdin)) {
      if (buf[strlen(buf) - 1] == '\n') buf[strlen(buf) - 1] = '\0';
      if (0 == strlen(buf)) break; // выход
#define MATCHSIZE 20      
      regmatch_t pmatch[MATCHSIZE];
      int rc = pcre2_regexec(&preg, (char*)buf, MATCHSIZE,
                             (regmatch_t*)&pmatch, REG_NOTBOL);
      if (rc == REG_NOMATCH ) {
         printf("no match found\n");         
         continue;
      }
      else if (rc != 0) {
         pcre2_regerror(rc, &preg, buf, SIZE);
         printf("error: %s\n", buf);
         continue;
      }

      for (int c = 0; c < MATCHSIZE; c ++) {
         if (-1 == pmatch[c].rm_so) break;
         printf("%d/%d : ", pmatch[c].rm_so, pmatch[c].rm_eo);
         for (int i = pmatch[c].rm_so; i < pmatch[c].rm_eo; i++) 
            printf("%c", buf[i]);
         printf("\n");    
      }
   }
   pcre2_regfree(&preg);
   return 0;
}
