#include <stdio.h>
#include <string.h>
#define PCRE2_CODE_UNIT_WIDTH 8
#include <pcre2.h>

int main(int argc, char *argv[]) {
#define SIZE 120
  unsigned char pattern[SIZE] = ".";
  if (argc > 1) strncpy((char*)pattern, argv[1], SIZE - 1);  
  size_t pattern_size = strlen((char*)pattern);
  uint32_t options = 0;
  size_t erroffset;
  int errcode;
  pcre2_code *re;
  char buf[SIZE];
  re = pcre2_compile(pattern, pattern_size, options, &errcode, &erroffset, NULL);
  if (re == NULL) {
    pcre2_get_error_message(errcode, (unsigned char*)buf, SIZE);
    printf("%d\t%s\n", errcode, buf);
    return 1;
  }
#define MATCHSIZE 20
  uint32_t ovecsize = MATCHSIZE * 2;
  pcre2_match_data *match_data = pcre2_match_data_create(ovecsize, NULL);
  while (fgets(buf, sizeof(buf) - 1, stdin)) {
    if (buf[strlen(buf) - 1] == '\n') buf[strlen(buf) - 1] = '\0';
    if (0 == strlen(buf)) break; // выход
    int rc = pcre2_match(re, (unsigned char*)buf, strlen(buf),
                         0, options, match_data, NULL);
    if(rc == 0) {
      printf("offset vector too small: %d", rc);
      continue;
    }
    else if (rc < 0) {
      printf("no match found\n");
      continue;
    }
    else if(rc > 0) {
      size_t* ovector; 
      ovector = pcre2_get_ovector_pointer(match_data);
      for(int i = 0; i < rc; i++) {
        printf("%ld/%ld : ", ovector[2 * i], ovector[2 * i + 1]); 
        char* start = buf + ovector[2 * i];
        size_t slen = ovector[2 * i + 1] - ovector[2 * i];
        printf("%.*s\n", (int)slen, (char*)start);
      }
    }
  }
  pcre2_match_data_free(match_data);
  pcre2_code_free(re);
  return 0;
}    
