#include <stdio.h>
#include <wchar.h>
#include <locale.h>
#include <string.h>
#define PCRE2_CODE_UNIT_WIDTH 32
#include <pcre2.h>

void c2w(const char *c, wchar_t *w) {
   int n = -1;
   while (n != 0)  
      c += (n = mbtowc(w++, c, MB_CUR_MAX)); 
}

int main(int argc, char *argv[]) {
  setlocale(LC_ALL, ""); // только после этого работают преобразования c2w()!
#define SIZE 120
  wchar_t wpattern[SIZE] = L".";
  if (argc > 1) c2w(argv[1], wpattern);
  size_t wpattern_size = wcslen(wpattern);
  uint32_t options = 0;
  size_t erroffset;
  int errcode;
  wchar_t wbuf[SIZE];
  pcre2_code* re = pcre2_compile((unsigned int*)wpattern, wpattern_size, 
                                 options, &errcode, &erroffset, NULL);
  if (re == NULL) {
    pcre2_get_error_message(errcode, (unsigned int*)wbuf, SIZE);
    printf("%d\t%ls\n", errcode, wbuf);
    return 1;
  }
#define MATCHSIZE 20
  uint32_t ovecsize = MATCHSIZE * 2;
  pcre2_match_data *match_data = pcre2_match_data_create(ovecsize, NULL);
  char buf[SIZE];
  while (fgets(buf, sizeof(buf) - 1, stdin)) {
    if (buf[strlen(buf) - 1] == '\n') buf[strlen(buf) - 1] = '\0';
    if (0 == strlen(buf)) break; // выход
    c2w(buf, wbuf);
    int rc = pcre2_match(re, (unsigned int*)wbuf, wcslen(wbuf),
                         0, options, match_data, NULL);
    if(rc == 0) {
      printf("offset vector too small: %d", rc);
      continue;
    }
    else if (rc < 0) {
      printf("no match found\n");
      continue;
    }
    else if(rc > 0) {
      size_t* ovector; 
      ovector = pcre2_get_ovector_pointer(match_data);
      for(int i = 0; i < rc; i++) {
        printf("%ld/%ld : ", ovector[2 * i], ovector[2 * i + 1]); 
        wchar_t* start = wbuf + ovector[2 * i];
        size_t slen = ovector[2 * i + 1] - ovector[2 * i];
        for (int j = 0; j < slen; j++) 
            printf("%lc", *(start + j));
        printf("\n");    
      }
    }
  }
  pcre2_match_data_free(match_data);
  pcre2_code_free(re);
  return 0;
}    
